#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <unistd.h> // usleep
#include <QString>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::grabScreenshot()
{
    int delay = 500;
    usleep(delay * 1000);
    m_regionGrabber = new RegionGrabber(std::bind(&MainWindow::dbgLog, this, std::placeholders::_1));
    connect(m_regionGrabber, SIGNAL(regionGrabbed(const QPixmap&)), this, SLOT(screenshotGrabbed(const QPixmap&)));
}

void MainWindow::screenshotGrabbed(const QPixmap &pixmap)
{
    delete m_regionGrabber;
    m_regionGrabber = 0;

    // Cancelled (pressed Escape):
    if (pixmap.isNull()) {
        dbgLog("screenshotGrabbed: Cancelled");
        return;
    }

    dbgLog(QString("screenshotGrabbed: %1x%2").arg(pixmap.width()).arg(pixmap.height()));
}

void MainWindow::dbgLog(QString msg)
{
    ui->textEdit->append(msg);
}

void MainWindow::on_buttonTakeScreenshot_clicked()
{
    grabScreenshot();
}
